'use strict'

var test = require('tape')

var cli = require('../cli')
var concat = require('terminus').concat
var agent = require('nsolid')
agent.on('test', function onTest (request) {
  request.return(request.value)
})

test('cli', function (t) {
  t.plan(2)
  t.equals(typeof cli, 'function')
  if (process.env.NSOLID_SOCKET) {
    // we're running an agent of our own, so we can test the cli against itself
    var socket = process.env.NSOLID_SOCKET
    if (!socket.indexOf(':') >= 0) {
      socket = 'localhost:' + socket
    }
    var out = cli('test', socket, {data: 'foo'})
    var done = concat(function (buf) {
      t.equals(buf.toString(), '"foo"')
    })
    out.pipe(done)
  } else {
    t.skip('run `NSOLID_SOCKET=5000 nsolid test/index.js` to test cli custom command')
  }
})
