'use strict'

const test = require('tape')

const spawn = require('child_process').spawn
const concat = require('terminus').concat
const path = require('path')
const fs = require('fs')

test('help', function (t) {
  t.plan(3)
  const child = spawn(process.execPath, [
    path.join(__dirname, '..', 'cli-bin.js'),
    '-h'
  ], {
    stdio: 'pipe'
  })
  child.stdout.pipe(concat(function (str) {
    t.equal(str.length, 0)
  }))
  child.stderr.pipe(concat(function (str) {
    const expected = fs.readFileSync(path.join(__dirname, '..', 'help.txt'))
    t.equal(String(str).trim(), String(expected).trim())
  }))
  child.on('exit', function (code) {
    t.equal(code, 0)
  })
})
