"use strict"

var through2 = require("through2")
var JSONstream = require("json-stream")

module.exports.rawFormat = through2.ctor()
module.exports.fromJsonLines = fromJsonLines
module.exports.toJsonLines = toJsonLines
module.exports.Consolize = Consolize

function fromJsonLines() {
  // convert from newline-delimited JSON to object stream
  return JSONstream()
}

function toJsonLines() {
  // stringify each record and print as rows (i.e. opposite of fromJsonLines)
  return through2.obj(function _write(chunk, encoding, callback) {
    this.push(JSON.stringify(chunk) + "\n")
    callback()
  })
}

// Add a final \n if we're in a TTY and it doesn't have one already
function Consolize() {
  var final = null
  return through2(function _noop(chunk, encoding, callback) {
    final = chunk[chunk.length - 1]
    callback(null, chunk)
  }, function _addNewline(callback) {
    if (process.stdout.isTTY) {
      if (final != 10) { // 0x10 = \n
        // only add newline if in TTY & doesn't already end with one
        this.push("\n")
      }
    }
    callback()
  })
}
